> For the complete documentation index, see [llms.txt](https://docs.platform9.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.platform9.com/api-docs/block-storage-service/attachments.md).

# Attachments

Volume attachment management

## List attachments

> Lists all volume attachments

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"attachments","description":"Volume attachment management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"parameters":{"LimitQuery":{"name":"limit","description":"Requests a page size of items","schema":{"minimum":1,"type":"integer"},"in":"query"},"MarkerQuery":{"name":"marker","description":"The ID of the last-seen item","schema":{"type":"string"},"in":"query"},"SortQuery":{"name":"sort","description":"Comma-separated list of sort keys and optional sort directions","schema":{"type":"string"},"in":"query"}},"schemas":{"Attachments":{"type":"object","properties":{"attachments":{"type":"array","items":{"$ref":"#/components/schemas/Attachment"}}}},"Attachment":{"type":"object","properties":{"id":{"format":"uuid","description":"The UUID of the attachment","type":"string"},"volume_id":{"format":"uuid","description":"The UUID of the volume","type":"string"},"instance":{"nullable":true,"format":"uuid","description":"The UUID of the instance","type":"string"},"status":{"description":"The attachment status","type":"string"},"attach_mode":{"description":"The attachment mode","type":"string"},"attached_at":{"nullable":true,"format":"date-time","description":"The date and time when attached","type":"string"},"detached_at":{"nullable":true,"format":"date-time","description":"The date and time when detached","type":"string"},"connector":{"nullable":true,"description":"Connector information","type":"object"},"connection_info":{"nullable":true,"description":"Connection information","type":"object"}}}}},"paths":{"/v3/attachments":{"get":{"tags":["attachments"],"parameters":[{"$ref":"#/components/parameters/LimitQuery"},{"$ref":"#/components/parameters/MarkerQuery"},{"$ref":"#/components/parameters/SortQuery"},{"name":"instance_id","description":"Filter by instance ID","schema":{"type":"string"},"in":"query"},{"name":"volume_id","description":"Filter by volume ID","schema":{"type":"string"},"in":"query"},{"name":"status","description":"Filter by attachment status","schema":{"type":"string"},"in":"query"},{"name":"attach_status","description":"Filter by attach status","schema":{"type":"string"},"in":"query"}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Attachments"}}},"description":"OK"}},"summary":"List attachments","description":"Lists all volume attachments"}}}}
```

## Create attachment

> Creates a volume attachment

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"attachments","description":"Volume attachment management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"schemas":{"AttachmentCreateRequest":{"type":"object","properties":{"attachment":{"required":["volume_uuid"],"type":"object","properties":{"volume_uuid":{"format":"uuid","description":"The UUID of the volume","type":"string"},"instance_uuid":{"format":"uuid","description":"The UUID of the instance","type":"string"},"connector":{"description":"Connector information","type":"object"},"mode":{"description":"Attachment mode (microversion 3.54+)","enum":["rw","ro"],"type":"string"}}}}},"AttachmentResponse":{"type":"object","properties":{"attachment":{"$ref":"#/components/schemas/Attachment"}}},"Attachment":{"type":"object","properties":{"id":{"format":"uuid","description":"The UUID of the attachment","type":"string"},"volume_id":{"format":"uuid","description":"The UUID of the volume","type":"string"},"instance":{"nullable":true,"format":"uuid","description":"The UUID of the instance","type":"string"},"status":{"description":"The attachment status","type":"string"},"attach_mode":{"description":"The attachment mode","type":"string"},"attached_at":{"nullable":true,"format":"date-time","description":"The date and time when attached","type":"string"},"detached_at":{"nullable":true,"format":"date-time","description":"The date and time when detached","type":"string"},"connector":{"nullable":true,"description":"Connector information","type":"object"},"connection_info":{"nullable":true,"description":"Connection information","type":"object"}}}}},"paths":{"/v3/attachments":{"post":{"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AttachmentCreateRequest"}}},"required":true},"tags":["attachments"],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AttachmentResponse"}}},"description":"OK"}},"summary":"Create attachment","description":"Creates a volume attachment"}}}}
```

## Show attachment details

> Shows details for an attachment

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"attachments","description":"Volume attachment management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"schemas":{"AttachmentResponse":{"type":"object","properties":{"attachment":{"$ref":"#/components/schemas/Attachment"}}},"Attachment":{"type":"object","properties":{"id":{"format":"uuid","description":"The UUID of the attachment","type":"string"},"volume_id":{"format":"uuid","description":"The UUID of the volume","type":"string"},"instance":{"nullable":true,"format":"uuid","description":"The UUID of the instance","type":"string"},"status":{"description":"The attachment status","type":"string"},"attach_mode":{"description":"The attachment mode","type":"string"},"attached_at":{"nullable":true,"format":"date-time","description":"The date and time when attached","type":"string"},"detached_at":{"nullable":true,"format":"date-time","description":"The date and time when detached","type":"string"},"connector":{"nullable":true,"description":"Connector information","type":"object"},"connection_info":{"nullable":true,"description":"Connection information","type":"object"}}}}},"paths":{"/v3/attachments/{attachment_id}":{"get":{"tags":["attachments"],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AttachmentResponse"}}},"description":"OK"}},"summary":"Show attachment details","description":"Shows details for an attachment"}}}}
```

## Update attachment

> Updates an attachment

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"attachments","description":"Volume attachment management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"schemas":{"AttachmentUpdateRequest":{"type":"object","properties":{"attachment":{"type":"object","properties":{"connector":{"description":"Connector information","type":"object"}}}}},"AttachmentResponse":{"type":"object","properties":{"attachment":{"$ref":"#/components/schemas/Attachment"}}},"Attachment":{"type":"object","properties":{"id":{"format":"uuid","description":"The UUID of the attachment","type":"string"},"volume_id":{"format":"uuid","description":"The UUID of the volume","type":"string"},"instance":{"nullable":true,"format":"uuid","description":"The UUID of the instance","type":"string"},"status":{"description":"The attachment status","type":"string"},"attach_mode":{"description":"The attachment mode","type":"string"},"attached_at":{"nullable":true,"format":"date-time","description":"The date and time when attached","type":"string"},"detached_at":{"nullable":true,"format":"date-time","description":"The date and time when detached","type":"string"},"connector":{"nullable":true,"description":"Connector information","type":"object"},"connection_info":{"nullable":true,"description":"Connection information","type":"object"}}}}},"paths":{"/v3/attachments/{attachment_id}":{"put":{"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AttachmentUpdateRequest"}}},"required":true},"tags":["attachments"],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AttachmentResponse"}}},"description":"OK"}},"summary":"Update attachment","description":"Updates an attachment"}}}}
```

## Delete attachment

> Deletes an attachment

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"attachments","description":"Volume attachment management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}}},"paths":{"/v3/attachments/{attachment_id}":{"delete":{"tags":["attachments"],"responses":{"200":{"content":{"application/json":{"schema":{"type":"object","properties":{"attachment_ids":{"type":"array","items":{"type":"string"}}}}}},"description":"OK"}},"summary":"Delete attachment","description":"Deletes an attachment"}}}}
```

## Complete attachment

> Mark a volume attachment process as completed (in-use)

```json
{"openapi":"3.0.3","info":{"title":"OpenStack Block Storage API (Cinder)","version":"3.71"},"tags":[{"name":"attachments","description":"Volume attachment management"}],"servers":[{"url":"https://{host}/cinder","description":"PCD Block Storage API v3","variables":{"host":{"default":"example.platform9.com","description":"The PCD controlplane hostname"}}}],"security":[{"pcdAuth":[]}],"components":{"securitySchemes":{"pcdAuth":{"name":"X-Auth-Token","type":"apiKey","in":"header","description":"PCD Identity Service token authentication"}},"schemas":{"CompleteAttachmentRequest":{"type":"object","properties":{"os-complete":{"type":"object"}}}}},"paths":{"/v3/attachments/{attachment_id}/action":{"post":{"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CompleteAttachmentRequest"}}},"required":true},"tags":["attachments"],"responses":{"204":{"description":"No Content"}},"summary":"Complete attachment","description":"Mark a volume attachment process as completed (in-use)"}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.platform9.com/api-docs/block-storage-service/attachments.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
